Doomsday Engine - Feature #1877

[Updater] Use Sparkle for automatic updates (on OS X)
2014-10-14 11:54 - skyjake

Status: New Start date: 2014-10-14
Priority: Normal % Done: 0%
Assignee: skyjake

Category: User experience

Target version: 3.x

Description

Sparkle is a popular OS X framework for handling automatic updates. Replacing Doomsday's own updater in favor of this would be
good for the user experience on OS X.

However, this may not be feasible until Snowberry is dropped and Doomsday can really be distributed/installed as a single app.

The Doomsday Shell would perhaps need to be distributed separately in this scenario.

Related issues:
Related to Feature #1643: Windows installer using WiX Toolset Closed 2013-10-27

History

#1 - 2014-10-14 15:05 - skyjake
There is also WinSparkle for Windows.

#2 - 2014-10-14 21:13 - danij

What are the practical benefits to using (Win)Sparkle compared to Doomsday's built-in Updater mechanism? I'm fairly happy with how it works
currently.

#3 - 2014-10-15 10:07 - skyjake

| suppose the main benefit would be on the Mac where our own updater is pretty wonkily implemented (generated scripts, etc.). Check out the bullet
points. | would say the best features are DSA signatures and generally being a robust, de facto solution for autoupdating used by many apps. It's
better to rely on existing, well-tested code than roll one's own, particularly when it comes to a relatively complex topic like automatic updates.

#4 - 2014-10-15 17:08 - danij

Well, most of those bullet points are already covered by Doomsday's own updater mechanism. The existing updater is:

It is fully integrated with Doomsday, unlike the Sparkle Ul which will necessarily be external and a completely different style.

By virtue of the fact Doomsday is already running at the time an update is installed, we can update in "secure locations" ourselves.

The one feature in that list I'm unsure of wrt Mac OS is DSA (I thought you were already signing the bundles? At least thats what the build script
appears to do).

| wonder if there is perhaps a Mac OS equivalent of WiX Toolset? http://wixtoolset.org/ On Windows this would give us the best of both worlds; 1)
standards-compliant and robust updating 2) fully integrated update Ul. From the looks of Sparkle, we'd be sacrificing one to improve the other?

#5 - 2014-10-15 17:53 - skyjake

This topic is highly platform-specific. On OS X, we are dealing with self-contained application bundles that are simple to update with a framework like
Sparkle. Not having to maintain this tricky piece of code ourselves would allow spending the time more productively. Also, the Ul that Sparkle
implements is pretty much de facto standard on Mac for apps' self-updating.

| thought you were already signing the bundles

Signatures are indeed produced, however no one is checking them during the auto-update process.

Mac OS equivalent of WiX Toolset

The build and packaging process on OS X is utterly dependent on Apple's tools (.pkg format, metadata, developer/installer signatures, etc.). It is
already being done appropriately for the platform.
On Windows we certainly do need something like WiX Toolset.

#6 - 2014-10-15 17:57 - skyjake
- Related to Feature #1643: Windows installer using WiX Toolset added

#7 - 2014-10-15 18:00 - danij

Being completely unfamiliar with the requirements of the Mac OS platform I'll bow to your better judgement here.

However as an outsider looking in, it appears to me that we'd be losing the nice integration with the Doomsday Ul if we switched to using Sparkle. I'd
say that is a high price to pay. At least in the Windows world, | very much like the fact updating is integrated with Doomsday.

#8 - 2019-11-29 21:08 - skyjake

- Target version set to 3.x
